import pytest
from NekUpload.NekData.data_type import BasisType, ExpansionType, IntegrationPoint

@pytest.mark.unit
def test_basis_type_order():
    # seems like a trivial test, but enforce order
    assert BasisType.NO_BASIS_TYPE.value == 1, "BasisType.NO_BASIS_TYPE should be 1"
    assert BasisType.ORTHO_A.value == 2, "BasisType.ORTHO_A should be 2"
    assert BasisType.ORTHO_B.value == 3, "BasisType.ORTHO_B should be 3"
    assert BasisType.ORTHO_C.value == 4, "BasisType.ORTHO_C should be 4"
    assert BasisType.MODIFIED_A.value == 5, "BasisType.MODIFIED_A should be 5"
    assert BasisType.MODIFIED_B.value == 6, "BasisType.MODIFIED_B should be 6"
    assert BasisType.MODIFIED_C.value == 7, "BasisType.MODIFIED_C should be 7"
    assert BasisType.ORTHO_PYR_C.value == 8, "BasisType.ORTHO_PYR_C should be 8"
    assert BasisType.MODIFIED_PYR_C.value == 9, "BasisType.MODIFIED_PYR_C should be 9"
    assert BasisType.FOURIER.value == 10, "BasisType.FOURIER should be 10"
    assert BasisType.GLL_LAGRANGE.value == 11, "BasisType.GLL_LAGRANGE should be 11"
    assert BasisType.GAUSS_LAGRANGE.value == 12, "BasisType.GAUSS_LAGRANGE should be 12"
    assert BasisType.LEGENDRE.value == 13, "BasisType.LEGENDRE should be 13"
    assert BasisType.CHEBYSHEV.value == 14, "BasisType.CHEBYSHEV should be 14"
    assert BasisType.MONONMIAL.value == 15, "BasisType.MONONMIAL should be 15"
    assert BasisType.FOURIER_SINGLE_MODE.value == 16, "BasisType.FOURIER_SINGLE_MODE should be 16"
    assert BasisType.FOURIER_HALF_MODE_RE.value == 17, "BasisType.FOURIER_HALF_MODE_RE should be 17"
    assert BasisType.FOURIER_HALF_MODE_IM.value == 18, "BasisType.FOURIER_HALF_MODE_IM should be 18"
    assert BasisType.SIZE_BASIS_TYPE.value == 19, "BasisType.SIZE_BASIS_TYPE should be 19"

@pytest.mark.unit
def test_expansion_type_order():
    # seems like a trivial test, but enforce order
    assert ExpansionType.NO_EXPANSION_TYPE.value == 1, "ExpansionType.NO_EXPANSION_TYPE should be 1"
    assert ExpansionType.MODIFIED.value == 2, "ExpansionType.MODIFIED should be 2"
    assert ExpansionType.MODIFIED_QUAD_PLUS_1.value == 3, "ExpansionType.MODIFIED_QUAD_PLUS_1 should be 3"
    assert ExpansionType.MODIFIED_QUAD_PLUS_2.value == 4, "ExpansionType.MODIFIED_QUAD_PLUS_2 should be 4"
    assert ExpansionType.MODIFIED_GLL_RADAU_10.value == 5, "ExpansionType.MODIFIED_GLL_RADAU_10 should be 5"
    assert ExpansionType.ORTHOGONAL.value == 6, "ExpansionType.ORTHOGONAL should be 6"
    assert ExpansionType.GLL_LAGRANGE.value == 7, "ExpansionType.GLL_LAGRANGE should be 7"
    assert ExpansionType.GLL_LAGRANGE_SEM.value == 8, "ExpansionType.GLL_LAGRANGE_SEM should be 8"
    assert ExpansionType.GAUSS_LAGRANGE.value == 9, "ExpansionType.GAUSS_LAGRANGE should be 9"
    assert ExpansionType.GAUSS_LAGRANGE_SEM.value == 10, "ExpansionType.GAUSS_LAGRANGE_SEM should be 10"
    assert ExpansionType.FOURIER.value == 11, "ExpansionType.FOURIER should be 11"
    assert ExpansionType.FOURIER_SINGLE_MODE.value == 12, "ExpansionType.FOURIER_SINGLE_MODE should be 12"
    assert ExpansionType.FOURIER_HALF_MODE_RE.value == 13, "ExpansionType.FOURIER_HALF_MODE_RE should be 13"
    assert ExpansionType.FOURIER_HALF_MODE_IM.value == 14, "ExpansionType.FOURIER_HALF_MODE_IM should be 14"
    assert ExpansionType.CHEBYSHEV.value == 15, "ExpansionType.CHEBYSHEV should be 15"
    assert ExpansionType.FOURIER_CHEBYSHEV.value == 16, "ExpansionType.FOURIER_CHEBYSHEV should be 16"
    assert ExpansionType.CHEBYSHEV_FOURIER.value == 17, "ExpansionType.CHEBYSHEV_FOURIER should be 17"
    assert ExpansionType.FOURIER_MODIFIED.value == 18, "ExpansionType.FOURIER_MODIFIED should be 18"
    assert ExpansionType.EXPANSION_TYPE_SIZE.value == 19, "ExpansionType.EXPANSION_TYPE_SIZE should be 19"

@pytest.mark.unit
def test_integration_point_order():
    # seems like a trivial test, but enforce order
    assert IntegrationPoint.GAUSS_GAUSS_LEGENDRE.value == 1, "IntegrationPoint.GAUSS_GAUSS_LEGENDRE should be 1"
    assert IntegrationPoint.GAUSS_RADAU_M_LEGENDRE.value == 2, "IntegrationPoint.GAUSS_RADAU_M_LEGENDRE should be 2"
    assert IntegrationPoint.GAUSS_RADAU_P_LEGENDRE.value == 3, "IntegrationPoint.GAUSS_RADAU_P_LEGENDRE should be 3"
    assert IntegrationPoint.GAUSS_LOBATTO_LEGENDRE.value == 4, "IntegrationPoint.GAUSS_LOBATTO_LEGENDRE should be 4"
    assert IntegrationPoint.GAUSS_GAUSS_CHEBYSHEV.value == 5, "IntegrationPoint.GAUSS_GAUSS_CHEBYSHEV should be 5"
    assert IntegrationPoint.GAUSS_RADAU_M_CHEBYSHEV.value == 6, "IntegrationPoint.GAUSS_RADAU_M_CHEBYSHEV should be 6"
    assert IntegrationPoint.GAUSS_RADAU_P_CHEBYSHEV.value == 7, "IntegrationPoint.GAUSS_RADAU_P_CHEBYSHEV should be 7"
    assert IntegrationPoint.GAUSS_LOBATTO_CHEBYSHEV.value == 8, "IntegrationPoint.GAUSS_LOBATTO_CHEBYSHEV should be 8"
    assert IntegrationPoint.GAUSS_RADAU_M_ALPHA0_BETA1.value == 9, "IntegrationPoint.GAUSS_RADAU_M_ALPHA0_BETA1 should be 9"
    assert IntegrationPoint.GAUSS_RADAU_M_ALPHA0_BETA2.value == 10, "IntegrationPoint.GAUSS_RADAU_M_ALPHA0_BETA2 should be 10"
    assert IntegrationPoint.GAUSS_RADAU_M_ALPHA1_BETA0.value == 11, "IntegrationPoint.GAUSS_RADAU_M_ALPHA1_BETA0 should be 11"
    assert IntegrationPoint.GAUSS_RADAU_M_ALPHA2_BETA0.value == 12, "IntegrationPoint.GAUSS_RADAU_M_ALPHA2_BETA0 should be 12"
    assert IntegrationPoint.GAUSS_KRONROD_LEGENDRE.value == 13, "IntegrationPoint.GAUSS_KRONROD_LEGENDRE should be 13"
    assert IntegrationPoint.GAUSS_RADAU_KRONROD_M_LEGENDRE.value == 14, "IntegrationPoint.GAUSS_RADAU_KRONROD_M_LEGENDRE should be 14"
    assert IntegrationPoint.GAUSS_RADAU_KRONROD_M_ALPHA1_BETA0.value == 15, "IntegrationPoint.GAUSS_RADAU_KRONROD_M_ALPHA1_BETA0 should be 15"
    assert IntegrationPoint.GAUSS_LOBATTO_KRONROD_LEGENDRE.value == 16, "IntegrationPoint.GAUSS_LOBATTO_KRONROD_LEGENDRE should be 16"
    assert IntegrationPoint.POLY_EVENLY_SPACED.value == 17, "IntegrationPoint.POLY_EVENLY_SPACED should be 17"
    assert IntegrationPoint.FOURIER_EVENLY_SPACED.value == 18, "IntegrationPoint.FOURIER_EVENLY_SPACED should be 18"
    assert IntegrationPoint.FOURIER_SINGLE_MODE_SPACED.value == 19, "IntegrationPoint.FOURIER_SINGLE_MODE_SPACED should be 19"
    assert IntegrationPoint.BOUNDARY_LAYER_POINTS.value == 20, "IntegrationPoint.BOUNDARY_LAYER_POINTS should be 20"
    assert IntegrationPoint.BOUNDARY_LAYER_POINTS_REV.value == 21, "IntegrationPoint.BOUNDARY_LAYER_POINTS_REV should be 21"
    assert IntegrationPoint.NODAL_TRI_ELEC.value == 22, "IntegrationPoint.NODAL_TRI_ELEC should be 22"
    assert IntegrationPoint.NODAL_TRI_FEKETE.value == 23, "IntegrationPoint.NODAL_TRI_FEKETE should be 23"
    assert IntegrationPoint.NODAL_TRI_EVENLY_SPACED.value == 24, "IntegrationPoint.NODAL_TRI_EVENLY_SPACED should be 24"
    assert IntegrationPoint.NODAL_TET_EVENLY_SPACED.value == 25, "IntegrationPoint.NODAL_TET_EVENLY_SPACED should be 25"
    assert IntegrationPoint.NODAL_TET_ELEC.value == 26, "IntegrationPoint.NODAL_TET_ELEC should be 26"
    assert IntegrationPoint.NODAL_PRISM_EVENLY_SPACED.value == 27, "IntegrationPoint.NODAL_PRISM_EVENLY_SPACED should be 27"
    assert IntegrationPoint.NODAL_PRISM_ELEC.value == 28, "IntegrationPoint.NODAL_PRISM_ELEC should be 28"
    assert IntegrationPoint.NODAL_TRI_SPI.value == 29, "IntegrationPoint.NODAL_TRI_SPI should be 29"
    assert IntegrationPoint.NODAL_TET_SPI.value == 30, "IntegrationPoint.NODAL_TET_SPI should be 30"
    assert IntegrationPoint.NODAL_PRISM_SPI.value == 31, "IntegrationPoint.NODAL_PRISM_SPI should be 31"
    assert IntegrationPoint.NODAL_QUAD_ELEC.value == 32, "IntegrationPoint.NODAL_QUAD_ELEC should be 32"
    assert IntegrationPoint.NODAL_HEX_ELEC.value == 33, "IntegrationPoint.NODAL_HEX_ELEC should be 33"
    assert IntegrationPoint.SIZE_POINTS_TYPE.value == 34, "IntegrationPoint.SIZE_POINTS_TYPE should be 34"