from NekUpload.testutils import NekTestDataset,NekTestGeometryComposite
import NekUpload.testutils
from NekUpload.NekData.data_type import SolverType
from pathlib import Path

def abs_path(file: str) -> str:
    absolute_path = Path(__file__).resolve().parent / file
    return str(absolute_path)

@NekUpload.testutils.dataset
@NekUpload.testutils.geometry_composite_info(
    geom_info=NekTestGeometryComposite(
        composite_id_to_definition_map={0:"Q[0-9]",1:"E[3]",2:"E[29]",
            3:"E[2,6,9,12,15,18,21,24,27,30,28,25,22,19,16,13,10,7,4,0]"
        },
        dim=2
    )
)
def LEE_2DVariableC_WeakDG_MODIFIED():
    return NekTestDataset(
        solver_type=SolverType.ACOUSTIC_SOLVER,
        session=abs_path("LEE_2DVariableC_WeakDG_MODIFIED.xml"),
        geometry=abs_path("LEE_2DVariableC_WeakDG_MODIFIED.nekg"),
        output=abs_path("LEE_2DVariableC_WeakDG_MODIFIED.fld"),
        checkpoints=[abs_path("LEE_2DVariableC_WeakDG_MODIFIED_0.chk"),abs_path("LEE_2DVariableC_WeakDG_MODIFIED_1.chk")]
    )
