from pathlib import Path
from NekUpload.testutils import NekTestDataset,NekTestGeometryComposite
import NekUpload.testutils
from NekUpload.NekData.data_type import SolverType

def abs_path(file: str) -> str:
    absolute_path = Path(__file__).resolve().parent / file
    return str(absolute_path)

@NekUpload.testutils.dataset
@NekUpload.testutils.geometry_composite_info(
    geom_info=NekTestGeometryComposite(
        composite_id_to_definition_map={1:"Q[0-255]",2:"E[3,27,44,61,78,95,112,129,146,163,180,197,214,231,248,265,282,299,316,333,350,367,384,401,418,435,452,469,486,503,520,537]",
            3:"E[23,40,57,74,91,108,125,142,159,176,193,210,227,244,261,278,295,312,329,346,363,380,397,414,431,448,465,482,499,516,533,550]",
            4:"E[0,4,7,10,13,16,19,22]",5:"E[536,539,541,543,545,547,549,551]"
        },
        dim=2
    )
)
def Nozzle_AxiSym_NoSwirl():
    return NekTestDataset(
        solver_type=SolverType.COMPRESSIBLE_FLOW_SOLVER,
        session=abs_path("Nozzle_AxiSym_NoSwirl.xml"),
        geometry=abs_path("Nozzle_AxiSym_NoSwirl.nekg"),
        output=abs_path("Nozzle_AxiSym_NoSwirl.fld"),
        checkpoints=[],
        filters=[],
        boundary_conditions=[]
    )