from NekUpload.testutils import NekTestDataset,NekTestGeometryComposite
import NekUpload.testutils
from NekUpload.NekData.data_type import SolverType
from pathlib import Path

def abs_path(file: str) -> str:
    absolute_path = Path(__file__).resolve().parent / file
    return str(absolute_path)

@NekUpload.testutils.dataset
@NekUpload.testutils.geometry_composite_info(
    geom_info=NekTestGeometryComposite(
        composite_id_to_definition_map={0:"Q[0-15]",1:"E[0-3]",2:"E[16-19]",
            3:"E[20,25,30,35]", 4:"E[24,29,34,39]"
        },
        dim=2
    )
)
def LinearSWE_StandingWave_WallBC_DG_P8():
    return NekTestDataset(
        solver_type=SolverType.SHALLOW_WATER_SOLVER,
        session=abs_path("LinearSWE_StandingWave_WallBC_DG_P8.xml"),
        geometry=abs_path("LinearSWE_StandingWave_WallBC_DG_P8.nekg"),
        output=abs_path("LinearSWE_StandingWave_WallBC_DG_P8.fld"),
        checkpoints=[abs_path("LinearSWE_StandingWave_WallBC_DG_P8_0.chk")]
    )
@NekUpload.testutils.dataset
def NonlinearSWE_RossbyModon_DG_P9():
    return NekTestDataset(
        solver_type=SolverType.SHALLOW_WATER_SOLVER,
        session=abs_path("NonlinearSWE_RossbyModon_DG_P9.xml"),
        geometry=abs_path("NonlinearSWE_RossbyModon_DG_P9.nekg"),
        output=abs_path("NonlinearSWE_RossbyModon_DG_P9.fld"),
        checkpoints=[abs_path("NonlinearSWE_RossbyModon_DG_P9_0.chk")]
    )
