import pytest
from NekUpload.metadata.relations import *
from typing import Any

@pytest.mark.unit
def test_to_json():
    
    id = "123456"
    relation = Relations(id,RelationsSchemes.DOI,RelationType.CONTINUES,ResourceType.DATASET)
    
    expected_json = {
        "identifier": id,
        "scheme": "doi",
        "relation_type": {
            "id": "continues",
            "title": {
                "en": "Continues"
            }
        },
        "resource_type": {
            "id": "dataset",
            "title": {
                "en": "Dataset"
            }
        }
    }
    
    json: dict[str,Any] = relation.to_json()

    assert json == expected_json, f"Expected {expected_json}, got {json}" 

@pytest.mark.unit
def test_from_json():
    json_data = {
        "identifier": "123456",
        "scheme": "doi",
        "relation_type": {
            "id": "continues",
            "title": {
                "en": "Continues"
            }
        },
        "resource_type": {
            "id": "dataset",
            "title": {
                "en": "Dataset"
            }
        }
    }

    relation = Relations.from_json(json_data)
    expected_relation = Relations("123456",RelationsSchemes.DOI,RelationType.CONTINUES,ResourceType.DATASET)

    assert relation == expected_relation, f"Expected {repr(expected_relation)}, got {repr(relation)}"
